pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar > Class Template Reference
Module registration

JointIterativeClosestPoint extends ICP to multiple frames which share the same transform. More...

`#include <pcl/registration/joint_icp.h>`

Inheritance diagram for pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >:

## Public Types

typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSource | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTarget | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef pcl::search::KdTree< PointTarget > | KdTree
typedef pcl::search::KdTree< PointTarget >::Ptr | KdTreePtr
typedef pcl::search::KdTree< PointSource > | KdTreeReciprocal
typedef KdTree::Ptr | KdTreeReciprocalPtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
typedef boost::shared_ptr< JointIterativeClosestPoint< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const JointIterativeClosestPoint< PointSource, PointTarget, Scalar > > | ConstPtr
typedef pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar > | CorrespondenceEstimation
typedef CorrespondenceEstimation::Ptr | CorrespondenceEstimationPtr
typedef CorrespondenceEstimation::ConstPtr | CorrespondenceEstimationConstPtr
typedef IterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix4 | Matrix4
Public Types inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
typedef Registration< PointSource, PointTarget, Scalar >::PointCloudSource | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef Registration< PointSource, PointTarget, Scalar >::PointCloudTarget | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef PointIndices::Ptr | PointIndicesPtr
typedef PointIndices::ConstPtr | PointIndicesConstPtr
typedef boost::shared_ptr< IterativeClosestPoint< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const IterativeClosestPoint< PointSource, PointTarget, Scalar > > | ConstPtr
typedef Registration< PointSource, PointTarget, Scalar >::Matrix4 | Matrix4
Public Types inherited from pcl::Registration< PointSource, PointTarget, Scalar >
typedef Eigen::Matrix< Scalar, 4, 4 > | Matrix4
typedef boost::shared_ptr< Registration< PointSource, PointTarget, Scalar > > | Ptr
typedef boost::shared_ptr< const Registration< PointSource, PointTarget, Scalar > > | ConstPtr
typedef pcl::registration::CorrespondenceRejector::Ptr | CorrespondenceRejectorPtr
typedef pcl::search::KdTree< PointTarget > | KdTree
typedef pcl::search::KdTree< PointTarget >::Ptr | KdTreePtr
typedef pcl::search::KdTree< PointSource > | KdTreeReciprocal
typedef KdTreeReciprocal::Ptr | KdTreeReciprocalPtr
typedef pcl::PointCloud< PointSource > | PointCloudSource
typedef PointCloudSource::Ptr | PointCloudSourcePtr
typedef PointCloudSource::ConstPtr | PointCloudSourceConstPtr
typedef pcl::PointCloud< PointTarget > | PointCloudTarget
typedef PointCloudTarget::Ptr | PointCloudTargetPtr
typedef PointCloudTarget::ConstPtr | PointCloudTargetConstPtr
typedef KdTree::PointRepresentationConstPtr | PointRepresentationConstPtr
typedef pcl::registration::TransformationEstimation< PointSource, PointTarget, Scalar > | TransformationEstimation
typedef TransformationEstimation::Ptr | TransformationEstimationPtr
typedef TransformationEstimation::ConstPtr | TransformationEstimationConstPtr
typedef pcl::registration::CorrespondenceEstimationBase< PointSource, PointTarget, Scalar > | CorrespondenceEstimation
typedef CorrespondenceEstimation::Ptr | CorrespondenceEstimationPtr
typedef CorrespondenceEstimation::ConstPtr | CorrespondenceEstimationConstPtr
Public Types inherited from pcl::PCLBase< PointSource >
typedef pcl::PointCloud< PointSource > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| JointIterativeClosestPoint ()
| Empty constructor. More...
virtual | ~JointIterativeClosestPoint ()
| Empty destructor. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
void | addInputSource (const PointCloudSourceConstPtr &cloud)
| Add a source cloud to the joint solver. More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &)
| Provide a pointer to the input target (e.g., the point cloud that we want to align to the target) More...
void | addInputTarget (const PointCloudTargetConstPtr &cloud)
| Add a target cloud to the joint solver. More...
void | addCorrespondenceEstimation (CorrespondenceEstimationPtr ce)
| Add a manual correspondence estimator If you choose to do this, you must add one for each input source / target pair. More...
void | clearInputSources ()
| Reset my list of input sources. More...
void | clearInputTargets ()
| Reset my list of input targets. More...
void | clearCorrespondenceEstimations ()
| Reset my list of correspondence estimation methods. More...
Public Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
| IterativeClosestPoint ()
| Empty constructor. More...
virtual | ~IterativeClosestPoint ()
| Empty destructor. More...
pcl::registration::DefaultConvergenceCriteria< Scalar >::Ptr | getConvergeCriteria ()
| Returns a pointer to the DefaultConvergenceCriteria used by the IterativeClosestPoint class. More...
virtual void | setInputSource (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
virtual void | setInputTarget (const PointCloudTargetConstPtr &cloud)
| Provide a pointer to the input target (e.g., the point cloud that we want to align to the target) More...
void | setUseReciprocalCorrespondences (bool use_reciprocal_correspondence)
| Set whether to use reciprocal correspondence or not. More...
bool | getUseReciprocalCorrespondences () const
| Obtain whether reciprocal correspondence are used or not. More...
Public Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
| Registration ()
| Empty constructor. More...
virtual | ~Registration ()
| destructor. More...
void | setTransformationEstimation (const TransformationEstimationPtr &te)
| Provide a pointer to the transformation estimation object. More...
void | setCorrespondenceEstimation (const CorrespondenceEstimationPtr &ce)
| Provide a pointer to the correspondence estimation object. More...
void | setInputCloud (const PointCloudSourceConstPtr &cloud)
| Provide a pointer to the input source (e.g., the point cloud that we want to align to the target) More...
PointCloudSourceConstPtr const | getInputCloud ()
| Get a pointer to the input point cloud dataset target. More...
PointCloudSourceConstPtr const | getInputSource ()
| Get a pointer to the input point cloud dataset target. More...
PointCloudTargetConstPtr const | getInputTarget ()
| Get a pointer to the input point cloud dataset target. More...
void | setSearchMethodTarget (const KdTreePtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the target cloud. More...
KdTreePtr | getSearchMethodTarget () const
| Get a pointer to the search method used to find correspondences in the target cloud. More...
void | setSearchMethodSource (const KdTreeReciprocalPtr &tree, bool force_no_recompute=false)
| Provide a pointer to the search object used to find correspondences in the source cloud (usually used by reciprocal correspondence finding). More...
KdTreeReciprocalPtr | getSearchMethodSource () const
| Get a pointer to the search method used to find correspondences in the source cloud. More...
Matrix4 | getFinalTransformation ()
| Get the final transformation matrix estimated by the registration method. More...
Matrix4 | getLastIncrementalTransformation ()
| Get the last incremental transformation matrix estimated by the registration method. More...
void | setMaximumIterations (int nr_iterations)
| Set the maximum number of iterations the internal optimization should run for. More...
int | getMaximumIterations ()
| Get the maximum number of iterations the internal optimization should run for, as set by the user. More...
void | setRANSACIterations (int ransac_iterations)
| Set the number of iterations RANSAC should run for. More...
double | getRANSACIterations ()
| Get the number of iterations RANSAC should run for, as set by the user. More...
void | setRANSACOutlierRejectionThreshold (double inlier_threshold)
| Set the inlier distance threshold for the internal RANSAC outlier rejection loop. More...
double | getRANSACOutlierRejectionThreshold ()
| Get the inlier distance threshold for the internal outlier rejection loop as set by the user. More...
void | setMaxCorrespondenceDistance (double distance_threshold)
| Set the maximum distance threshold between two correspondent points in source <-> target. More...
double | getMaxCorrespondenceDistance ()
| Get the maximum distance threshold between two correspondent points in source <-> target. More...
void | setTransformationEpsilon (double epsilon)
| Set the transformation epsilon (maximum allowable difference between two consecutive transformations) in order for an optimization to be considered as having converged to the final solution. More...
double | getTransformationEpsilon ()
| Get the transformation epsilon (maximum allowable difference between two consecutive transformations) as set by the user. More...
void | setEuclideanFitnessEpsilon (double epsilon)
| Set the maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | getEuclideanFitnessEpsilon ()
| Get the maximum allowed distance error before the algorithm will be considered to have converged, as set by the user. More...
void | setPointRepresentation (const PointRepresentationConstPtr &point_representation)
| Provide a boost shared pointer to the PointRepresentation to be used when comparing points. More...
template<typename FunctionSignature >
bool | registerVisualizationCallback (boost::function< FunctionSignature > &visualizerCallback)
| Register the user callback function which will be called from registration thread in order to update point cloud obtained after each iteration. More...
double | getFitnessScore (double max_range=std::numeric_limits< double >::max())
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) More...
double | getFitnessScore (const std::vector< float > &distances_a, const std::vector< float > &distances_b)
| Obtain the Euclidean fitness score (e.g., sum of squared distances from the source to the target) from two sets of correspondence distances (distances between source and target points) More...
bool | hasConverged ()
| Return the state of convergence after the last align run. More...
void | align (PointCloudSource &output)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
void | align (PointCloudSource &output, const Matrix4 &guess)
| Call the registration algorithm which estimates the transformation and returns the transformed source (input) as output. More...
const std::string & | getClassName () const
| Abstract class get name method. More...
bool | initCompute ()
| Internal computation initalization. More...
bool | initComputeReciprocal ()
| Internal computation when reciprocal lookup is needed. More...
void | addCorrespondenceRejector (const CorrespondenceRejectorPtr &rejector)
| Add a new correspondence rejector to the list. More...
std::vector< CorrespondenceRejectorPtr > | getCorrespondenceRejectors ()
| Get the list of correspondence rejectors. More...
bool | removeCorrespondenceRejector (unsigned int i)
| Remove the i-th correspondence rejector in the list. More...
void | clearCorrespondenceRejectors ()
| Clear the list of correspondence rejectors. More...
Public Member Functions inherited from pcl::PCLBase< PointSource >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointSource & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual void | computeTransformation (PointCloudSource &output, const Matrix4 &guess)
| Rigid transformation computation method with initial guess. More...
void | determineRequiredBlobData ()
| Looks at the Estimators and Rejectors and determines whether their blob-setter methods need to be called. More...
Protected Member Functions inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
virtual void | transformCloud (const PointCloudSource &input, PointCloudSource &output, const Matrix4 &transform)
| Apply a rigid transform to a given dataset. More...
Protected Member Functions inherited from pcl::Registration< PointSource, PointTarget, Scalar >
bool | searchForNeighbors (const PointCloudSource &cloud, int index, std::vector< int > &indices, std::vector< float > &distances)
| Search for the closest nearest neighbor of a given point. More...
Protected Member Functions inherited from pcl::PCLBase< PointSource >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

std::vector< PointCloudSourceConstPtr > | sources_
std::vector< PointCloudTargetConstPtr > | targets_
std::vector< CorrespondenceEstimationPtr > | correspondence_estimations_
Protected Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
size_t | x_idx_offset_
| XYZ fields offset. More...
size_t | y_idx_offset_
size_t | z_idx_offset_
size_t | nx_idx_offset_
| Normal fields offset. More...
size_t | ny_idx_offset_
size_t | nz_idx_offset_
bool | use_reciprocal_correspondence_
| The correspondence type used for correspondence estimation. More...
bool | source_has_normals_
| Internal check whether source dataset has normals or not. More...
bool | target_has_normals_
| Internal check whether target dataset has normals or not. More...
bool | need_source_blob_
| Checks for whether estimators and rejectors need various data. More...
bool | need_target_blob_
Protected Attributes inherited from pcl::Registration< PointSource, PointTarget, Scalar >
std::string | reg_name_
| The registration method name. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
KdTreeReciprocalPtr | tree_reciprocal_
| A pointer to the spatial search object of the source. More...
int | nr_iterations_
| The number of iterations the internal optimization ran for (used internally). More...
int | max_iterations_
| The maximum number of iterations the internal optimization should run for. More...
int | ransac_iterations_
| The number of iterations RANSAC should run for. More...
PointCloudTargetConstPtr | target_
| The input point cloud dataset target. More...
Matrix4 | final_transformation_
| The final transformation matrix estimated by the registration method after N iterations. More...
Matrix4 | transformation_
| The transformation matrix estimated by the registration method. More...
Matrix4 | previous_transformation_
| The previous transformation matrix estimated by the registration method (used internally). More...
double | transformation_epsilon_
| The maximum difference between two consecutive transformations in order to consider convergence (user defined). More...
double | euclidean_fitness_epsilon_
| The maximum allowed Euclidean error between two consecutive steps in the ICP loop, before the algorithm is considered to have converged. More...
double | corr_dist_threshold_
| The maximum distance threshold between two correspondent points in source <-> target. More...
double | inlier_threshold_
| The inlier distance threshold for the internal RANSAC outlier rejection loop. More...
bool | converged_
| Holds internal convergence state, given user parameters. More...
int | min_number_correspondences_
| The minimum number of correspondences that the algorithm needs before attempting to estimate the transformation. More...
CorrespondencesPtr | correspondences_
| The set of correspondences determined at this ICP step. More...
TransformationEstimationPtr | transformation_estimation_
| A TransformationEstimation object, used to calculate the 4x4 rigid transformation. More...
CorrespondenceEstimationPtr | correspondence_estimation_
| A CorrespondenceEstimation object, used to estimate correspondences between the source and the target cloud. More...
std::vector< CorrespondenceRejectorPtr > | correspondence_rejectors_
| The list of correspondence rejectors to use. More...
bool | target_cloud_updated_
| Variable that stores whether we have a new target cloud, meaning we need to pre-process it again. More...
bool | source_cloud_updated_
| Variable that stores whether we have a new source cloud, meaning we need to pre-process it again. More...
bool | force_no_recompute_
| A flag which, if set, means the tree operating on the target cloud will never be recomputed. More...
bool | force_no_recompute_reciprocal_
| A flag which, if set, means the tree operating on the source cloud will never be recomputed. More...
boost::function< void(const pcl::PointCloud< PointSource > &cloud_src, const std::vector< int > &indices_src, const pcl::PointCloud< PointTarget > &cloud_tgt, const std::vector< int > &indices_tgt)> | update_visualizer_
| Callback function to update intermediate source point cloud position during it's registration to the target point cloud. More...
Protected Attributes inherited from pcl::PCLBase< PointSource >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Public Attributes inherited from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >
pcl::registration::DefaultConvergenceCriteria< Scalar >::Ptr | convergence_criteria_

## Detailed Description

### template<typename PointSource, typename PointTarget, typename Scalar = float>
class pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >

JointIterativeClosestPoint extends ICP to multiple frames which share the same transform.

This is particularly useful when solving for camera extrinsics using multiple observations. When given a single pair of clouds, this reduces to vanilla ICP.

Author
  Stephen Miller

Definition at line 55 of file joint_icp.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef boost::shared_ptr<const JointIterativeClosestPoint<PointSource, PointTarget, Scalar> > pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::ConstPtr

Definition at line 77 of file joint_icp.h.

## CorrespondenceEstimation

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef pcl::registration::CorrespondenceEstimationBase<PointSource, PointTarget, Scalar> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::CorrespondenceEstimation

Definition at line 79 of file joint_icp.h.

## CorrespondenceEstimationConstPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef CorrespondenceEstimation::ConstPtr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::CorrespondenceEstimationConstPtr

Definition at line 81 of file joint_icp.h.

## CorrespondenceEstimationPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef CorrespondenceEstimation::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::CorrespondenceEstimationPtr

Definition at line 80 of file joint_icp.h.

## KdTree

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef pcl::search::KdTree<PointTarget> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::KdTree

Definition at line 66 of file joint_icp.h.

## KdTreePtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef pcl::search::KdTree<PointTarget>::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::KdTreePtr

Definition at line 67 of file joint_icp.h.

## KdTreeReciprocal

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef pcl::search::KdTree<PointSource> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::KdTreeReciprocal

Definition at line 69 of file joint_icp.h.

## KdTreeReciprocalPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef KdTree::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::KdTreeReciprocalPtr

Definition at line 70 of file joint_icp.h.

## Matrix4

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::Matrix4 pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::Matrix4

Definition at line 116 of file joint_icp.h.

## PointCloudSource

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::PointCloudSource pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSource

Definition at line 58 of file joint_icp.h.

## PointCloudSourceConstPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointCloudSource::ConstPtr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSourceConstPtr

Definition at line 60 of file joint_icp.h.

## PointCloudSourcePtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointCloudSource::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudSourcePtr

Definition at line 59 of file joint_icp.h.

## PointCloudTarget

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef IterativeClosestPoint<PointSource, PointTarget, Scalar>::PointCloudTarget pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTarget

Definition at line 62 of file joint_icp.h.

## PointCloudTargetConstPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointCloudTarget::ConstPtr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTargetConstPtr

Definition at line 64 of file joint_icp.h.

## PointCloudTargetPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointCloudTarget::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointCloudTargetPtr

Definition at line 63 of file joint_icp.h.

## PointIndicesConstPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointIndices::ConstPtr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointIndicesConstPtr

Definition at line 74 of file joint_icp.h.

## PointIndicesPtr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef PointIndices::Ptr pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::PointIndicesPtr

Definition at line 73 of file joint_icp.h.

## Ptr

template<typename PointSource , typename PointTarget , typename Scalar = float>

typedef boost::shared_ptr<JointIterativeClosestPoint<PointSource, PointTarget, Scalar> > pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::Ptr

Definition at line 76 of file joint_icp.h.

## Constructor & Destructor Documentation

## JointIterativeClosestPoint()

template<typename PointSource , typename PointTarget , typename Scalar = float>

pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::JointIterativeClosestPoint | ( |  | ) |

inline

Empty constructor.

Definition at line 119 of file joint_icp.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::reg_name_.

## ~JointIterativeClosestPoint()

template<typename PointSource , typename PointTarget , typename Scalar = float>

virtual pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::~JointIterativeClosestPoint | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 126 of file joint_icp.h.

## Member Function Documentation

## addCorrespondenceEstimation()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addCorrespondenceEstimation | ( | CorrespondenceEstimationPtr | ce | ) |

inline

Add a manual correspondence estimator If you choose to do this, you must add one for each input source / target pair.

They do not need to have trees or input clouds set ahead of time.

Parameters

  [in] | ce | Correspondence estimation

Definition at line 185 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::correspondence_estimations_.

## addInputSource()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addInputSource | ( | const PointCloudSourceConstPtr & | cloud | ) |

inline

Add a source cloud to the joint solver.

Parameters

  [in] | cloud | source cloud

Definition at line 145 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::sources_.

## addInputTarget()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addInputTarget | ( | const PointCloudTargetConstPtr & | cloud | ) |

inline

Add a target cloud to the joint solver.

Parameters

  [in] | cloud | target cloud

Definition at line 169 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::targets_.

## clearCorrespondenceEstimations()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearCorrespondenceEstimations | ( |  | ) |

inline

Reset my list of correspondence estimation methods.

Definition at line 205 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::computeTransformation(), pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::correspondence_estimations_, and pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::determineRequiredBlobData().

## clearInputSources()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearInputSources | ( |  | ) |

inline

Reset my list of input sources.

Definition at line 193 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::sources_.

## clearInputTargets()

template<typename PointSource , typename PointTarget , typename Scalar = float>

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearInputTargets | ( |  | ) |

inline

Reset my list of input targets.

Definition at line 199 of file joint_icp.h.

References pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::targets_.

## computeTransformation()

template<typename PointSource , typename PointTarget , typename Scalar >

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::computeTransformation | ( | PointCloudSource & | output,
|  | const Matrix4 & | guess
| ) |  |

protected virtual

Rigid transformation computation method with initial guess.

Parameters

  output | the transformed input point cloud dataset using the rigid transformation found
  guess | the initial guess of the transformation to compute

Reimplemented from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >.

Definition at line 49 of file joint_icp.hpp.

References pcl::Correspondence::index_match, pcl::Correspondence::index_query, and pcl::toPCLPointCloud2().

Referenced by pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearCorrespondenceEstimations().

## determineRequiredBlobData()

template<typename PointSource , typename PointTarget , typename Scalar >

void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::determineRequiredBlobData | ( |  | ) |

protected virtual

Looks at the Estimators and Rejectors and determines whether their blob-setter methods need to be called.

Reimplemented from pcl::IterativeClosestPoint< PointSource, PointTarget, Scalar >.

Definition at line 283 of file joint_icp.hpp.

Referenced by pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearCorrespondenceEstimations().

## setInputSource()

template<typename PointSource , typename PointTarget , typename Scalar = float>

virtual void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputSource | ( | const PointCloudSourceConstPtr & |  | ) |

inline virtual

Provide a pointer to the input source (e.g., the point cloud that we want to align to the target)

Reimplemented from pcl::Registration< PointSource, PointTarget, Scalar >.

Definition at line 133 of file joint_icp.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::getClassName().

## setInputTarget()

template<typename PointSource , typename PointTarget , typename Scalar = float>

virtual void pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::setInputTarget | ( | const PointCloudTargetConstPtr & |  | ) |

inline virtual

Provide a pointer to the input target (e.g., the point cloud that we want to align to the target)

Reimplemented from pcl::Registration< PointSource, PointTarget, Scalar >.

Definition at line 157 of file joint_icp.h.

References pcl::Registration< PointSource, PointTarget, Scalar >::getClassName().

## Member Data Documentation

## correspondence_estimations_

template<typename PointSource , typename PointTarget , typename Scalar = float>

std::vector<CorrespondenceEstimationPtr> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::correspondence_estimations_

protected

Definition at line 224 of file joint_icp.h.

Referenced by pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addCorrespondenceEstimation(), and pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearCorrespondenceEstimations().

## sources_

template<typename PointSource , typename PointTarget , typename Scalar = float>

std::vector<PointCloudSourceConstPtr> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::sources_

protected

Definition at line 222 of file joint_icp.h.

Referenced by pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addInputSource(), and pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearInputSources().

## targets_

template<typename PointSource , typename PointTarget , typename Scalar = float>

std::vector<PointCloudTargetConstPtr> pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::targets_

protected

Definition at line 223 of file joint_icp.h.

Referenced by pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::addInputTarget(), and pcl::JointIterativeClosestPoint< PointSource, PointTarget, Scalar >::clearInputTargets().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/registration/include/pcl/registration/joint_icp.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/registration/include/pcl/registration/impl/joint_icp.hpp